﻿//-----------------------------------------------------------------------
// <copyright file="InitializableActor.cs" company="Akka.NET Project">
//     Copyright (C) 2009-2015 Typesafe Inc. <http://www.typesafe.com>
//     Copyright (C) 2013-2015 Akka.NET project <https://github.com/akkadotnet/akka.net>
// </copyright>
//-----------------------------------------------------------------------

namespace Akka.Actor.Internals
{
    /// <summary>
    /// Marks that the actor needs to be initialized directly after it has been created.
    /// <remarks>Note! Part of internal API. Breaking changes may occur without notice. Use at own risk.</remarks>
    /// </summary>
    public interface IInitializableActor
    {
        void Init();
    }
}

